﻿Module Module1


    Function crc16(packet() As Byte, packet_lenght As Integer) As Integer
        'declare variables
        Dim xor_loops As Byte
        Dim message_byte As UInt16
        Dim crc As UInt16 = &HFFFF
        Dim poly As UInt16 = &HA001
        Dim rotate_carry As Boolean
        Dim mbyte As Byte
        Dim upper_crc As UInt16
        Dim lower_crc As UInt16

        'loop through message
        For mbyte = 1 To packet_lenght
            'get message byte 
            message_byte = Convert.ToInt32(packet(mbyte))

            'xor crc with message byte
            crc = crc Xor message_byte
            'xor 8 times
            For xor_loops = 1 To 8
                'check for carry
                If crc And 1 Then rotate_carry = True Else rotate_carry = False
                If rotate_carry = True Then crc = crc - 1
                crc = crc / 2
                'xor with poly if carry
                If rotate_carry = True Then crc = crc Xor poly
            Next xor_loops
        Next mbyte

        'byte swap
        upper_crc = (crc And &HFF00) / 256
        lower_crc = crc And &HFF
        'return crc
        crc16 = lower_crc * 256 + upper_crc

    End Function

    Public Function string_hex_to_byte(string_byte As String) As Byte
        Dim lsc As Char
        Dim msc As Char
        Dim lsb As Byte
        Dim msb As Byte
        msc = Mid(string_byte, 1, 1)
        If Len(string_byte) > 1 Then lsc = Mid(string_byte, 2, 1)
        msb = char_to_byte(msc) * 16
        lsb = char_to_byte(lsc)
        string_hex_to_byte = msb + lsb
    End Function

    Public Function char_to_byte(input_char As String) As Byte
        '48 = 0 to 57 = 9'
        'A = 65 to  70 = F
        If Asc(input_char) >= 48 And Asc(input_char) <= 57 Then
            '0 - 9
            char_to_byte = Asc(input_char) - 48
        Else
            If Asc(input_char) >= 65 And Asc(input_char) <= 70 Then
                'A - F
                char_to_byte = Asc(input_char) - 55
            Else
                'Not Hex
                char_to_byte = 0
            End If
        End If
    End Function
    Public Function byte_to_char(input_byte As String) As Byte
        '48 = 0 to 57 = 9'
        'A = 65 to  70 = F
        If input_byte <= 9 Then
            '0 - 9
            byte_to_char = input_byte + 48
        Else
            'A - F
            byte_to_char = input_byte + 55
        End If
    End Function
End Module
